diff --git a/libavcodec/raw.c b/libavcodec/raw.c
index 4b77be4157..086823c06e 100644
--- a/libavcodec/raw.c
+++ b/libavcodec/raw.c
@@ -237,6 +237,7 @@ static const PixelFormatTag raw_pix_fmt_tags[] = {
     { AV_PIX_FMT_YUYV422, MKTAG('y', 'u', 'v', '2') },
     { AV_PIX_FMT_YUYV422, MKTAG('y', 'u', 'v', 's') },
     { AV_PIX_FMT_YUYV422, MKTAG('D', 'V', 'O', 'O') }, /* Digital Voodoo SD 8 Bit */
+    { AV_PIX_FMT_VYU444,  MKTAG('v', '3', '0', '8') },
     { AV_PIX_FMT_UYVA,    MKTAG('v', '4', '0', '8') },
     { AV_PIX_FMT_AYUV,    MKTAG('y', '4', '0', '8') },
     { AV_PIX_FMT_RGB555LE,MKTAG('L', '5', '5', '5') },
diff --git a/libavformat/riff.c b/libavformat/riff.c
index 02f6b5ebc6..7ee04c70f4 100644
--- a/libavformat/riff.c
+++ b/libavformat/riff.c
@@ -296,6 +296,7 @@ const AVCodecTag ff_codec_bmp_tags[] = {
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('I', '4', 'C', 'B') },
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('I', '0', 'F', 'L') },
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('I', '0', 'F', 'B') },
+    { AV_CODEC_ID_RAWVIDEO,     MKTAG('v', '3', '0', '8') },
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('v', '4', '0', '8') },
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('y', '4', '0', '8') },
     { AV_CODEC_ID_FRWU,         MKTAG('F', 'R', 'W', 'U') },
diff --git a/tests/ref/fate/filter-pixdesc-vyu444 b/tests/ref/fate/filter-pixdesc-vyu444
index 7572621e76..a08abee73d 100644
--- a/tests/ref/fate/filter-pixdesc-vyu444
+++ b/tests/ref/fate/filter-pixdesc-vyu444
@@ -1 +1 @@
-pixdesc-vyu444      ae888f94235dd6d122c4fa3aa40f11d0
+pixdesc-vyu444      be62739ab38a49b86c0ed51f21de29e4
diff --git a/tests/ref/fate/filter-pixfmts-copy b/tests/ref/fate/filter-pixfmts-copy
index 121bf63a8e..c585b3cbd1 100644
--- a/tests/ref/fate/filter-pixfmts-copy
+++ b/tests/ref/fate/filter-pixfmts-copy
@@ -101,7 +101,7 @@ uyva                8896d7525f12de08818a01a5d5cf84f1
 uyvy422             3bcf3c80047592f2211fae3260b1b65d
 vuya                3d5e934651cae1ce334001cb1829ad22
 vuyx                0af13a42f9d0932c5a9bb6a8a5d1c5ee
-vyu444              2b2e6df31f5895340f25d6f67572b113
+vyu444              93912234400a4373b1a6b5c4e4b1a4ef
 x2bgr10le           550c0d190cf695afa4eaacb644db6b75
 x2rgb10le           c1e3ac21be04a16bb157b22784524520
 xv30le              c14b5a953bf3be56346f66ca174a5b1b
diff --git a/tests/ref/fate/filter-pixfmts-crop b/tests/ref/fate/filter-pixfmts-crop
index 25971e5b35..4d3b042aa3 100644
--- a/tests/ref/fate/filter-pixfmts-crop
+++ b/tests/ref/fate/filter-pixfmts-crop
@@ -98,7 +98,7 @@ rgba64le            fea8ebfc869b52adf353778f29eac7a7
 uyva                03f362ac6a39f25286bc6616111b0752
 vuya                76578a705ff3a37559653c1289bd03dd
 vuyx                615241c5406eb556fca0ad8606c23a02
-vyu444              a6067a24e63385242948dbc4c5a4ab5d
+vyu444              5d976b25782ff69e4b3b18453fa1447b
 x2bgr10le           84de725b85662c362862820dc4a309aa
 x2rgb10le           f4265aca7a67dbfa9354370098ca6f33
 xv30le              a9edb820819b900a4a897fee4562a4fb
diff --git a/tests/ref/fate/filter-pixfmts-field b/tests/ref/fate/filter-pixfmts-field
index 7117898f51..8dd6e6149f 100644
--- a/tests/ref/fate/filter-pixfmts-field
+++ b/tests/ref/fate/filter-pixfmts-field
@@ -101,7 +101,7 @@ uyva                147398d2e8d310f915c95863ad192c5e
 uyvy422             1c49e44ab3f060e85fc4a3a9464f045e
 vuya                f72bcf29d75cd143d0c565f7cc49119a
 vuyx                3d02eeab336d0a8106f6fdd91be61073
-vyu444              09fcf24f46ed72d51983d87ad3bed864
+vyu444              b139fb4ddaef12a7542a68277211efa7
 x2bgr10le           dbe21538d7cb1744914f6bd46ec09b55
 x2rgb10le           a18bc4ae5274e0a8cca9137ecd50c677
 xv30le              e940366c78efc9e292e9de28cf04dba9
diff --git a/tests/ref/fate/filter-pixfmts-fieldorder b/tests/ref/fate/filter-pixfmts-fieldorder
index c36e382b3f..41c6607ec7 100644
--- a/tests/ref/fate/filter-pixfmts-fieldorder
+++ b/tests/ref/fate/filter-pixfmts-fieldorder
@@ -90,7 +90,7 @@ uyva                ccf5dfd33765dda88c4b4afa2ea31305
 uyvy422             75de70e31c435dde878002d3f22b238a
 vuya                a3891d4168ff208948fd0b3ba0910495
 vuyx                9e4480c5fcb7c091ec3e517420764ef3
-vyu444              e2e54e73f81389559a972f4049ab8606
+vyu444              3ddab207d561a3ee5efae09e504207f2
 x2bgr10le           86474d84f26c5c51d6f75bf7e1de8da8
 x2rgb10le           cdf6a9e8a8d081aa768c6ae2e6221676
 xv30le              25aac48128d94010a3660839500caee5
diff --git a/tests/ref/fate/filter-pixfmts-hflip b/tests/ref/fate/filter-pixfmts-hflip
index be0161c91a..9fe32c8ea4 100644
--- a/tests/ref/fate/filter-pixfmts-hflip
+++ b/tests/ref/fate/filter-pixfmts-hflip
@@ -98,7 +98,7 @@ rgba64le            0c810d8b3a6bca10321788e1cb145340
 uyva                a8391c24037e2a670196b47bf6a2ca57
 vuya                7e530261e7ac4eae4fd616fd7572d0b8
 vuyx                f1d087284fb1556d76e6def5f94bf273
-vyu444              a9377d852b8263e50987593be7b03c7a
+vyu444              7b72337f92a7223fd115265e2f769276
 x2bgr10le           827cc659f29378e00c5a7d2c0ada8f9a
 x2rgb10le           d4a8189b65395a88d0a38a7053f3359f
 xv30le              072aa2b61ce1e764f9d1957e8abee9a9
diff --git a/tests/ref/fate/filter-pixfmts-il b/tests/ref/fate/filter-pixfmts-il
index 5f9d34d4e0..b14571ef09 100644
--- a/tests/ref/fate/filter-pixfmts-il
+++ b/tests/ref/fate/filter-pixfmts-il
@@ -100,7 +100,7 @@ uyva                d2655e1a1c56bcb48f7c7a6a6270dd93
 uyvy422             d6ee3ca43356d08c392382b24b22cda5
 vuya                b9deab5ba249dd608b709c09255a4932
 vuyx                4251d94ee49e6a3cc1c10c09cd331308
-vyu444              cd6598487e9f9e2c7165b656c486eade
+vyu444              50e9e24a38afc81541a536d06aab5ebe
 x2bgr10le           135acaff8318cf9861bb0f7849a9e5e9
 x2rgb10le           517fb186f523dc7cdc5c5c6967cfbe94
 xv30le              7f6414a3fc700380025c29812e8376a9
diff --git a/tests/ref/fate/filter-pixfmts-null b/tests/ref/fate/filter-pixfmts-null
index 121bf63a8e..c585b3cbd1 100644
--- a/tests/ref/fate/filter-pixfmts-null
+++ b/tests/ref/fate/filter-pixfmts-null
@@ -101,7 +101,7 @@ uyva                8896d7525f12de08818a01a5d5cf84f1
 uyvy422             3bcf3c80047592f2211fae3260b1b65d
 vuya                3d5e934651cae1ce334001cb1829ad22
 vuyx                0af13a42f9d0932c5a9bb6a8a5d1c5ee
-vyu444              2b2e6df31f5895340f25d6f67572b113
+vyu444              93912234400a4373b1a6b5c4e4b1a4ef
 x2bgr10le           550c0d190cf695afa4eaacb644db6b75
 x2rgb10le           c1e3ac21be04a16bb157b22784524520
 xv30le              c14b5a953bf3be56346f66ca174a5b1b
diff --git a/tests/ref/fate/filter-pixfmts-pad b/tests/ref/fate/filter-pixfmts-pad
index 3ed65ebced..72571e94ab 100644
--- a/tests/ref/fate/filter-pixfmts-pad
+++ b/tests/ref/fate/filter-pixfmts-pad
@@ -45,7 +45,7 @@ rgba                b157c90191463d34fb3ce77b36c96386
 uyva                06271af718417c21d5bc6a992b04c32a
 vuya                44368c0a758ee68e24ce976e3b1b8535
 vuyx                ff637b205b78ee581e393124d0f44f5d
-vyu444              88fde4581eb7369d7ff28bb27268b169
+vyu444              cf5d49d5c870f9e724fca104f847bfa1
 ya16le              dfc900a8130a7c5e64201557cbaef50a
 ya8                 5d25e9a7975805d3f0dac516a6132b6e
 yuv410p             cb871dcc1e84a7ef1d21f9237b88cf6e
diff --git a/tests/ref/fate/filter-pixfmts-scale b/tests/ref/fate/filter-pixfmts-scale
index 6eeba28a7f..6f26936fbf 100644
--- a/tests/ref/fate/filter-pixfmts-scale
+++ b/tests/ref/fate/filter-pixfmts-scale
@@ -101,7 +101,7 @@ uyva                2358038be6dac002a6c736e798a3d91c
 uyvy422             aeb4ba4f9f003ae21f6d18089198244f
 vuya                ffa817e283bf6a0b6fba21b07523ccaa
 vuyx                a6ff68f46c6b4b7595ec91b2a497df8e
-vyu444              0e5edaa26029501f05c0693321d60ded
+vyu444              d663334119da56e36aca1e8e4eb29a39
 x2bgr10le           d57b9a99033cc7b65ddd111578f2d385
 x2rgb10le           d56bdb23fa6a8e12a0b4394987f89935
 xv30le              afe68d8a47e8460e0164970b1da0c5be
diff --git a/tests/ref/fate/filter-pixfmts-transpose b/tests/ref/fate/filter-pixfmts-transpose
index d5851f8278..2e78517079 100644
--- a/tests/ref/fate/filter-pixfmts-transpose
+++ b/tests/ref/fate/filter-pixfmts-transpose
@@ -90,7 +90,7 @@ rgba64le            ad47197774858858ae7b0c177dffa459
 uyva                cb773ee5a9f8964b9c826d55f9f425a3
 vuya                9ece18a345beb17cd19e09e443eca4bf
 vuyx                46b5b821d7ee6ddedb3ddafd1e5b007c
-vyu444              508978bb072eba1bc4636a4abd68dbe2
+vyu444              e70a294738165223928fddc9970b8381
 x2bgr10le           4aa774b6d8f6d446a64f1f288e5c97eb
 x2rgb10le           09cb1d98fe17ad8a6d9d3bec97ddc845
 xv30le              b1ac5a12f46d32c70acb63f89838ab76
diff --git a/tests/ref/fate/filter-pixfmts-vflip b/tests/ref/fate/filter-pixfmts-vflip
index c653e8d484..d2e134e974 100644
--- a/tests/ref/fate/filter-pixfmts-vflip
+++ b/tests/ref/fate/filter-pixfmts-vflip
@@ -101,7 +101,7 @@ uyva                d43e89ba3d5c9274e1948eac8630fcc6
 uyvy422             3a237e8376264e0cfa78f8a3fdadec8a
 vuya                fb849f76e56181e005c31fce75d7038c
 vuyx                ed7de87da324b39090a8961dfd56ca5a
-vyu444              5a98e2118b75a3804bb80003cf6fa731
+vyu444              815de7c57dc8afafb3de908a4a280582
 x2bgr10le           795b66a5fc83cd2cf300aae51c230f80
 x2rgb10le           262c502230cf3724f8e2cf4737f18a42
 xv30le              7e29ee107a1fabf3c7251f337d4b9fe5