diff --git a/libavcodec/raw.c b/libavcodec/raw.c
index acdd79ded8..4b77be4157 100644
--- a/libavcodec/raw.c
+++ b/libavcodec/raw.c
@@ -237,6 +237,7 @@ static const PixelFormatTag raw_pix_fmt_tags[] = {
     { AV_PIX_FMT_YUYV422, MKTAG('y', 'u', 'v', '2') },
     { AV_PIX_FMT_YUYV422, MKTAG('y', 'u', 'v', 's') },
     { AV_PIX_FMT_YUYV422, MKTAG('D', 'V', 'O', 'O') }, /* Digital Voodoo SD 8 Bit */
+    { AV_PIX_FMT_UYVA,    MKTAG('v', '4', '0', '8') },
     { AV_PIX_FMT_AYUV,    MKTAG('y', '4', '0', '8') },
     { AV_PIX_FMT_RGB555LE,MKTAG('L', '5', '5', '5') },
     { AV_PIX_FMT_RGB565LE,MKTAG('L', '5', '6', '5') },
diff --git a/libavformat/riff.c b/libavformat/riff.c
index b079b00f6c..02f6b5ebc6 100644
--- a/libavformat/riff.c
+++ b/libavformat/riff.c
@@ -296,6 +296,7 @@ const AVCodecTag ff_codec_bmp_tags[] = {
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('I', '4', 'C', 'B') },
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('I', '0', 'F', 'L') },
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('I', '0', 'F', 'B') },
+    { AV_CODEC_ID_RAWVIDEO,     MKTAG('v', '4', '0', '8') },
     { AV_CODEC_ID_RAWVIDEO,     MKTAG('y', '4', '0', '8') },
     { AV_CODEC_ID_FRWU,         MKTAG('F', 'R', 'W', 'U') },
     { AV_CODEC_ID_R10K,         MKTAG('R', '1', '0', 'k') },
diff --git a/tests/ref/fate/filter-pixdesc-uyva b/tests/ref/fate/filter-pixdesc-uyva
index 49fd1bc6b1..684562877e 100644
--- a/tests/ref/fate/filter-pixdesc-uyva
+++ b/tests/ref/fate/filter-pixdesc-uyva
@@ -1 +1 @@
-pixdesc-uyva        7cec5f820722500f491c3495113e726e
+pixdesc-uyva        646d7fbb9600f80590d9a7cff4919cd5
diff --git a/tests/ref/fate/filter-pixfmts-copy b/tests/ref/fate/filter-pixfmts-copy
index 4910c1b9ed..419d0e9bd9 100644
--- a/tests/ref/fate/filter-pixfmts-copy
+++ b/tests/ref/fate/filter-pixfmts-copy
@@ -97,7 +97,7 @@ rgb8                7ac6008c84d622c2fc50581706e17576
 rgba                b6e1b441c365e03b5ffdf9b7b68d9a0c
 rgba64be            ae2ae04b5efedca3505f47c4dd6ea6ea
 rgba64le            b91e1d77f799eb92241a2d2d28437b15
-uyva                affad7282152bcce415bdf228df00ae4
+uyva                8896d7525f12de08818a01a5d5cf84f1
 uyvy422             3bcf3c80047592f2211fae3260b1b65d
 v30xle              b5ec677137b6f1d9f14a2386a1a7a526
 vuya                3d5e934651cae1ce334001cb1829ad22
diff --git a/tests/ref/fate/filter-pixfmts-crop b/tests/ref/fate/filter-pixfmts-crop
index 7fe2876e40..0ee93f570a 100644
--- a/tests/ref/fate/filter-pixfmts-crop
+++ b/tests/ref/fate/filter-pixfmts-crop
@@ -95,7 +95,7 @@ rgb8                9b364a8f112ad9459fec47a51cc03b30
 rgba                9488ac85abceaf99a9309eac5a87697e
 rgba64be            89910046972ab3c68e2a348302cc8ca9
 rgba64le            fea8ebfc869b52adf353778f29eac7a7
-uyva                caa03b07812dbb6c48b5fb34edf73962
+uyva                03f362ac6a39f25286bc6616111b0752
 v30xle              f92c959d672e17a3a27351e671757212
 vuya                76578a705ff3a37559653c1289bd03dd
 vuyx                615241c5406eb556fca0ad8606c23a02
diff --git a/tests/ref/fate/filter-pixfmts-field b/tests/ref/fate/filter-pixfmts-field
index 51107d7b91..364fae0882 100644
--- a/tests/ref/fate/filter-pixfmts-field
+++ b/tests/ref/fate/filter-pixfmts-field
@@ -97,7 +97,7 @@ rgb8                62c3b9e2a171de3d894a8eeb271c85e8
 rgba                ee616262ca6d67b7ecfba4b36c602ce3
 rgba64be            23c8c0edaabe3eaec89ce69633fb0048
 rgba64le            dfdba4de4a7cac9abf08852666c341d3
-uyva                c1c2953840061e3778842051b078a41e
+uyva                147398d2e8d310f915c95863ad192c5e
 uyvy422             1c49e44ab3f060e85fc4a3a9464f045e
 v30xle              265a463ad722cfaede2fa6cb5e9bf34e
 vuya                f72bcf29d75cd143d0c565f7cc49119a
diff --git a/tests/ref/fate/filter-pixfmts-fieldorder b/tests/ref/fate/filter-pixfmts-fieldorder
index 72af3664b8..aa9bea3d52 100644
--- a/tests/ref/fate/filter-pixfmts-fieldorder
+++ b/tests/ref/fate/filter-pixfmts-fieldorder
@@ -86,7 +86,7 @@ rgb8                6deae05ccac5c50bd0d9c9fe8e124557
 rgba                1fdf872a087a32cd35b80cc7be399578
 rgba64be            5598f44514d122b9a57c5c92c20bbc61
 rgba64le            b34e6e30621ae579519a2d91a96a0acf
-uyva                fa5df2c0474b2a41dbe2210372b15fcc
+uyva                ccf5dfd33765dda88c4b4afa2ea31305
 uyvy422             75de70e31c435dde878002d3f22b238a
 v30xle              1f04ac91824200d94d7841736c41f728
 vuya                a3891d4168ff208948fd0b3ba0910495
diff --git a/tests/ref/fate/filter-pixfmts-hflip b/tests/ref/fate/filter-pixfmts-hflip
index 0592290ebc..7d17f057d1 100644
--- a/tests/ref/fate/filter-pixfmts-hflip
+++ b/tests/ref/fate/filter-pixfmts-hflip
@@ -95,7 +95,7 @@ rgb8                68a3a575badadd9e4f90226209f11699
 rgba                51961c723ea6707e0a410cd3f21f15d3
 rgba64be            c910444019f4cfbf4d995227af55da8d
 rgba64le            0c810d8b3a6bca10321788e1cb145340
-uyva                9266fd7374abf86f7035e356574586f0
+uyva                a8391c24037e2a670196b47bf6a2ca57
 v30xle              1c62803a7a7c0c89e5fda3d41cc0a376
 vuya                7e530261e7ac4eae4fd616fd7572d0b8
 vuyx                f1d087284fb1556d76e6def5f94bf273
diff --git a/tests/ref/fate/filter-pixfmts-il b/tests/ref/fate/filter-pixfmts-il
index 04a12e53a6..6e5f11ca46 100644
--- a/tests/ref/fate/filter-pixfmts-il
+++ b/tests/ref/fate/filter-pixfmts-il
@@ -96,7 +96,7 @@ rgb8                93f9fa5ecf522abe13ed34f21831fdfe
 rgba                625d8f4bd39c4bdbf61eb5e4713aecc9
 rgba64be            db70d33aa6c06f3e0a1c77bd11284261
 rgba64le            a8a2daae04374a27219bc1c890204007
-uyva                f16f848f8283bcd59da6a4d85bc5b0a0
+uyva                d2655e1a1c56bcb48f7c7a6a6270dd93
 uyvy422             d6ee3ca43356d08c392382b24b22cda5
 v30xle              267a4c668b14157d35399302bb978ac1
 vuya                b9deab5ba249dd608b709c09255a4932
diff --git a/tests/ref/fate/filter-pixfmts-null b/tests/ref/fate/filter-pixfmts-null
index 4910c1b9ed..419d0e9bd9 100644
--- a/tests/ref/fate/filter-pixfmts-null
+++ b/tests/ref/fate/filter-pixfmts-null
@@ -97,7 +97,7 @@ rgb8                7ac6008c84d622c2fc50581706e17576
 rgba                b6e1b441c365e03b5ffdf9b7b68d9a0c
 rgba64be            ae2ae04b5efedca3505f47c4dd6ea6ea
 rgba64le            b91e1d77f799eb92241a2d2d28437b15
-uyva                affad7282152bcce415bdf228df00ae4
+uyva                8896d7525f12de08818a01a5d5cf84f1
 uyvy422             3bcf3c80047592f2211fae3260b1b65d
 v30xle              b5ec677137b6f1d9f14a2386a1a7a526
 vuya                3d5e934651cae1ce334001cb1829ad22
diff --git a/tests/ref/fate/filter-pixfmts-pad b/tests/ref/fate/filter-pixfmts-pad
index f995db4237..3ed65ebced 100644
--- a/tests/ref/fate/filter-pixfmts-pad
+++ b/tests/ref/fate/filter-pixfmts-pad
@@ -42,7 +42,7 @@ rgb0                0984eb985dabbe757ed6beb53db84eff
 rgb24               17f9e2e0c609009acaf2175c42d4a2a5
 rgb48le             ed08db9b1aa50d69b8c3d73db93e390e
 rgba                b157c90191463d34fb3ce77b36c96386
-uyva                be076f4efae6b51032c5fc676a31f2cc
+uyva                06271af718417c21d5bc6a992b04c32a
 vuya                44368c0a758ee68e24ce976e3b1b8535
 vuyx                ff637b205b78ee581e393124d0f44f5d
 vyu444              88fde4581eb7369d7ff28bb27268b169
diff --git a/tests/ref/fate/filter-pixfmts-scale b/tests/ref/fate/filter-pixfmts-scale
index b6516d2970..57c530b487 100644
--- a/tests/ref/fate/filter-pixfmts-scale
+++ b/tests/ref/fate/filter-pixfmts-scale
@@ -97,7 +97,7 @@ rgb8                bcdc033b4ef0979d060dbc8893d4db58
 rgba                85bb5d03cea1c6e8002ced3373904336
 rgba64be            ee73e57923af984b31cc7795d13929da
 rgba64le            783d2779adfafe3548bdb671ec0de69e
-uyva                ee83c7ba25cfc997de70a4e5b3eb398f
+uyva                2358038be6dac002a6c736e798a3d91c
 uyvy422             aeb4ba4f9f003ae21f6d18089198244f
 v30xle              42be9fac7725274bf54012b073ee0e91
 vuya                ffa817e283bf6a0b6fba21b07523ccaa
diff --git a/tests/ref/fate/filter-pixfmts-transpose b/tests/ref/fate/filter-pixfmts-transpose
index e7fa2ca852..5902d90910 100644
--- a/tests/ref/fate/filter-pixfmts-transpose
+++ b/tests/ref/fate/filter-pixfmts-transpose
@@ -87,7 +87,7 @@ rgb8                c90feb30c3c9391ef5f470209d7b7a15
 rgba                4d76a9542143752a4ac30f82f88f68f1
 rgba64be            a60041217f4c0cd796d19d3940a12a41
 rgba64le            ad47197774858858ae7b0c177dffa459
-uyva                1500c3f52e32b2080be180d2e8196a7b
+uyva                cb773ee5a9f8964b9c826d55f9f425a3
 v30xle              8a31095e6eb8e85ab6f030773fa20d03
 vuya                9ece18a345beb17cd19e09e443eca4bf
 vuyx                46b5b821d7ee6ddedb3ddafd1e5b007c
diff --git a/tests/ref/fate/filter-pixfmts-vflip b/tests/ref/fate/filter-pixfmts-vflip
index edcd3ed3d3..73d9d3297e 100644
--- a/tests/ref/fate/filter-pixfmts-vflip
+++ b/tests/ref/fate/filter-pixfmts-vflip
@@ -97,7 +97,7 @@ rgb8                7df049b6094f8a5e084d74462f6d6cde
 rgba                c1a5908572737f2ae1e5d8218af65f4b
 rgba64be            17e6273323b5779b5f3f775f150c1011
 rgba64le            48f45b10503b7dd140329c3dd0d54c98
-uyva                0d2d0d286d841ea5b35cc06626dcafe4
+uyva                d43e89ba3d5c9274e1948eac8630fcc6
 uyvy422             3a237e8376264e0cfa78f8a3fdadec8a
 v30xle              1b2e25e974fdcd53b396b577725d33cb
 vuya                fb849f76e56181e005c31fce75d7038c